global
  log 127.0.0.1 local0
  log 127.0.0.1 local1 notice
  maxconn 4096
  tune.ssl.default-dh-param 2048
  ssl-default-bind-ciphers ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305
  ssl-default-bind-ciphersuites TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256
  ssl-default-bind-options prefer-client-ciphers no-sslv3 no-tlsv10 no-tlsv11 no-tls-tickets

  ssl-default-server-ciphers ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305
  ssl-default-server-ciphersuites TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256
  ssl-default-server-options no-sslv3 no-tlsv10 no-tlsv11 no-tls-tickets

userlist haproxy-dataplaneapi
  user {{ capi_haproxy_dataplane_user }} insecure-password {{ capi_haproxy_dataplane_password }}

program api
  command /usr/local/bin/dataplaneapi -f /usr/local/etc/haproxy/dataplaneapi.yml
  no option start-on-reload

defaults
  log global
  mode http
  option httplog
  option dontlognull
  timeout connect 10s
  timeout client 1800s
  timeout client-fin 50s
  timeout server 1800s
  timeout tunnel 1h

frontend stats
  bind *:{{ capi_haproxy_stats_port }}
  mode http
  stats enable
  stats hide-version
  stats realm Haproxy\ Statistics
  stats uri {{ capi_haproxy_stats_path }}
  stats auth {{ capi_haproxy_stats_user }}:{{ capi_haproxy_stats_password }}
  stats refresh 10s
  stats admin if LOCALHOST

frontend k8s-apiserver
  bind *:{{ capi_haproxy_k8sapi_port }}
  mode tcp
  option tcplog
  default_backend k8s-apiserver

backend k8s-apiserver
  mode tcp
  balance roundrobin
  option httpchk
  option log-health-checks
  http-check connect ssl
  http-check send meth GET uri /livez
  http-check expect status 200
  default-server inter 10s downinter 5s rise 2 fall 2 slowstart 60s maxconn 250 maxqueue 256 weight 100
  {%- for key, value in capi_haproxy_backend_servers %}
  server {{ key }} {{ value.host }}:{{ value.port | default(capi_haproxy_k8sapi_port) }} check verify none
  {%- endfor %}
